/*
    Text maid for Windows
    copyright (c) 1998-2018 Kazuki Iwamoto https://www.maid.org/ iwm@maid.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "associate.h"
#include "common.h"
#include "dialog.h"
#include "other.h"
#include "resource.h"


/******************************************************************************
*                                                                             *
* ja:t@C^Cv̑I֐Q                                               *
*                                                                             *
******************************************************************************/
BOOL CALLBACK
AssociateDlgProc (HWND   hDlg,
                  UINT   uMsg,
                  WPARAM wParam,
                  LPARAM lParam)
{
  static int *lpnPos;

  switch (uMsg)
    {
      case WM_INITDIALOG:
        {
          int i;
          LPTSTR lpszText;

          lpnPos = (int *)lParam;
          if (*lpnPos > nFileType)
            *lpnPos = 0;
          for (i = 0; i < nFileType; i++)
            SendDlgItemMessage (hDlg, IDC_LISTBOX41, LB_ADDSTRING,
                                            0, (LPARAM)lpFileType[i].szText);
          lpszText = LoadText (hInst, IDS_FTYPE_NOTYPE);
          SendDlgItemMessage (hDlg, IDC_LISTBOX41, LB_ADDSTRING,
                                            0, (LPARAM)lpszText);
          MemoryFree (lpszText);
          SendDlgItemMessage (hDlg, IDC_LISTBOX41, LB_SETCURSEL, *lpnPos, 0);
        }
        return TRUE;
      case WM_COMMAND:
        switch (LOWORD (wParam))
          {
            case IDC_LISTBOX41:
              if (HIWORD (wParam) == LBN_SELCHANGE)
                {
                  /* ja:Rg[̕\ */
                  int n;

                  n = SendDlgItemMessage (hDlg, IDC_LISTBOX41, LB_GETCURSEL,
                                                                        0, 0);
                  if (!EnableDlgItem (hDlg, IDOK, n != LB_ERR && n != *lpnPos))
                    {
                      MessageBox (hDlg, _T("EnableDlgItem"),
                                    APPLICATION, MB_OK | MB_ICONEXCLAMATION);
                      EndDialog (hDlg, IDCANCEL);
                    }
                }
              if (HIWORD (wParam) != LBN_DBLCLK)
                return TRUE;
            case IDOK:
              *lpnPos = SendDlgItemMessage (hDlg, IDC_LISTBOX41, LB_GETCURSEL,
                                                                        0, 0);
              if (*lpnPos != LB_ERR)
                {
                  if (*lpnPos >= nFileType)
                    *lpnPos = -1;
                  if (!EndDialog (hDlg, IDOK))
                    MessageBox (hDlg, _T("EndDialog"),
                                    APPLICATION, MB_OK | MB_ICONEXCLAMATION);
                  return TRUE;
                }
            case IDCANCEL:
              if (!EndDialog (hDlg, IDCANCEL))
                MessageBox (hDlg, _T("EndDialog"),
                                APPLICATION, MB_OK | MB_ICONEXCLAMATION);
                return TRUE;
          }
    }
  return FALSE;
}
